/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * Copyright (C) 2010 Red Hat, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 *
 * Author: Jan Görig <jgorig@redhat.com>
 */

#ifndef LIBNMSERVER_DBUS_H
#define LIBNMSERVER_DBUS_H

#include <netinet/in.h>
#include "libnmserver.h"

typedef struct
{
	char **devices;
	int count;
} nmserver_devices_t;

DBusConnection* nmserver_dbus_init(void);
void nmserver_dbus_close(DBusConnection *conn);

DBusMessage* nmserver_dbus_get_property(DBusConnection *conn,
					const char *target, const char *path,
					const char *interface, const char *name);

nmserver_result_t nmserver_dbus_get_nameservers(DBusConnection *conn,
						const char *path,
						in_addr_t **servers);

nmserver_result_t nmserver_dbus_get_ip4config(DBusConnection *conn,
					      const char *path,
					      char **ip4config);

nmserver_result_t nmserver_dbus_get_devices(DBusConnection *conn,
					    nmserver_devices_t *devices);

void nmserver_dbus_free_devices(nmserver_devices_t *devices);

nmserver_result_t nmserver_dbus_callback_nameservers(nmserver_control_t *control);
int nmserver_dbus_loop(nmserver_control_t *control);

#endif
